import { Authority } from "./Authority";
export declare class AuthorityFactory {
    /**
     * Use when Authority is B2C and validateAuthority is set to True to provide list of allowed domains.
     */
    static setKnownAuthorities(validateAuthority: boolean, knownAuthorities: Array<string>): void;
    /**
     * Parse the url and determine the type of authority
     */
    private static detectAuthorityFromUrl;
    /**
     * Create an authority object of the correct type based on the url
     * Performs basic authority validation - checks to see if the authority is of a valid type (eg aad, b2c)
     */
    static CreateInstance(authorityUrl: string, validateAuthority: boolean): Authority;
}
